import 'package:universal_io/io.dart';
import 'package:lokalise_flutter_sdk/ota/exceptions/api_exception.dart';

class Downloader {
  /// Download bundle
  static Future<List<int>> downloadBundle(String url) async {
    final httpClient = HttpClient();
    final response = await httpClient
        .getUrl(Uri.parse(url))
        .onError((Object e, StackTrace stackTrace) {
      throw ApiException('Failed to download bundle file', 0, e.toString());
    }).then((request) => request.close());

    if (response.statusCode != 200) {
      throw ApiException('Failed to download bundle file', response.statusCode);
    } else {
      return await response.fold([], (List<int> accumulator, List<int> next) {
        return accumulator..addAll(next);
      });
    }
  }
}
